#include <windows.h>

LRESULT CALLBACK WindowFunc (HWND, UINT, WPARAM, LPARAM);
char szWinName[]=" Paint";
HDC memdc; //  
HBITMAP hbit;    //   
HBRUSH hbrush; //  
HBRUSH hOldbrush; //  
HPEN hRedpen; //  
HPEN hOldpen; //  
int col1=1; 
int col2=1;
int maxX,maxY;

int WINAPI WinMain (HINSTANCE hThisInst, HINSTANCE hPrevInst, LPSTR lpszArgs, int nWinMode)
{
	HWND hwnd;
	MSG msg;
	WNDCLASSEX wcl;

	wcl.hInstance=hThisInst;
	wcl.lpszClassName=szWinName;
	wcl.lpfnWndProc=WindowFunc;
	wcl.style=0;
	wcl.cbSize=sizeof(WNDCLASSEX);
	wcl.hIcon=LoadIcon(NULL,IDI_APPLICATION);
	wcl.hIconSm=LoadIcon(NULL,IDI_WINLOGO);
	wcl.hCursor=LoadCursor(NULL,IDC_ARROW);
	wcl.lpszMenuName=NULL;
	wcl.cbClsExtra=0;
	wcl.cbWndExtra=0;

	wcl.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH);

	if (!RegisterClassEx(&wcl)) return 0;
   
	hwnd=CreateWindow(szWinName," Paint",WS_OVERLAPPEDWINDOW
		,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,HWND_DESKTOP,NULL,hThisInst,NULL);

	ShowWindow(hwnd,nWinMode);

	while (GetMessage(&msg,NULL,0,0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return (msg.wParam);
}

LRESULT CALLBACK WindowFunc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int xPos,yPos;    //  
	HDC hdc;          //   
	PAINTSTRUCT paintstruct; //-  
	COLORREF color; // 
	int obj;        //  
	switch(message)
	{
	case WM_CREATE:
	    maxX=GetSystemMetrics(SM_CXSCREEN);
		maxY=GetSystemMetrics(SM_CYSCREEN); 
		hdc=GetDC(hwnd);
		memdc=CreateCompatibleDC(hdc);
		hbit=CreateCompatibleBitmap(hdc,maxX,maxY);
	    SelectObject(memdc,hbit);
 		hbrush=(HBRUSH)GetStockObject(WHITE_BRUSH);
	    SelectObject (memdc,hbrush);
	    PatBlt(memdc,0,0,maxX,maxY,PATCOPY);
	    hRedpen=CreatePen(PS_SOLID,1,RGB(255,0,0));
		ReleaseDC(hwnd,hdc);
    break;
	
	case WM_LBUTTONDOWN:
		xPos=LOWORD(lParam);
        yPos=HIWORD(lParam);
		obj=(col2==1?BLACK_BRUSH:LTGRAY_BRUSH);
		hOldbrush=(HBRUSH)SelectObject (memdc,GetStockObject(obj));
		hOldpen=(HPEN)SelectObject(memdc,hRedpen);
		Rectangle(memdc,xPos,yPos,xPos+80,yPos+80);
		SelectObject(memdc,hOldpen);
		if (col2)col2=0;else col2=1;
		color =(col1==1?RGB(250,0,0):RGB(0,0,250));
		hbrush=(HBRUSH)CreateSolidBrush(color);
		SelectObject(memdc,hbrush);
		Ellipse(memdc,xPos+10,yPos+10,xPos+70,yPos+70);
		DeleteObject(hbrush);
		SelectObject(memdc,hOldbrush);
		if (col1)col1=0;else col1=1;
		InvalidateRect(hwnd,NULL,0);
	break;
    
	case WM_PAINT:
		hdc=BeginPaint(hwnd,&paintstruct);
		BitBlt(hdc,0,0,maxX,maxY,memdc,0,0,SRCCOPY);
		EndPaint(hwnd,&paintstruct);
	break;
	
	case WM_DESTROY: 
		DeleteObject(hRedpen);
		DeleteDC(memdc);
		PostQuitMessage(0);
	break;
	
	default:
 	return DefWindowProc(hwnd,message,wParam,lParam);
	}
return 0;
}
